#ifndef __ACTION_MAP_H__
#define __ACTION_MAP_H__

#include "boost/shared_ptr.hpp"
#include <string>
#include <vector>

namespace te
{
class datagram;

//#############################################################################
// inherit from this class to have your action handler
class action
{
public: //---------------------------------------------------------------------
    action ()
    {
    }
//-----------------------------------------------------------------------------
    virtual ~action()
    {
    }
//-----------------------------------------------------------------------------
    virtual void invoke(){}; // use this method to perform your action
//-----------------------------------------------------------------------------
    virtual void setParams(datagram& dgram){};
private: //--------------------------------------------------------------------
};
//#############################################################################
typedef action reaction;
//#############################################################################
typedef boost::shared_ptr<action> action_ptr;
//#############################################################################
typedef boost::shared_ptr<reaction> reaction_ptr;
//#############################################################################
enum dummy
{
    dummy = 0
};
//############################################################################
enum clientToServer
{
    exit     = 1, // order server to exit
    map_make = 2, // request a server to create a map
    area_req = 3  // request a rectangle of tile leafs
};
//#############################################################################
enum serverToClient
{
    set_map_size  = 1,
    leaf_send     = 2,
    date_and_time = 3
};
//#############################################################################
    class action_dummy : public action
    {
        void invoke()
        {
        };
    };
//#############################################################################
class action_map
{
public: //---------------------------------------------------------------------
    action_map (std::string& config) // read keys from a config file
    {
    }
    action_map (std::string config) // read keys from a config file by value
    {
    }
//-----------------------------------------------------------------------------
    ~action_map()
    {
    }
//-----------------------------------------------------------------------------
    action_ptr& operator[](size_t pos)
    {
        return my_actions_[pos];
    }
//-----------------------------------------------------------------------------
    void associate(int kVal, action_ptr aVal)
    {
        if (size_t(kVal) >= my_actions_.size())
        {
            my_actions_.resize(kVal+1);
        }
        my_actions_[kVal] = aVal;
    }
private:  //-------------------------------------------------------------------
    std::vector<action_ptr> my_actions_;
};
//#############################################################################
typedef action_map reaction_map;
//#############################################################################
};
#endif
