#include "server.h"
#include "client.h"

#include "server_actions.h"
#include "client_actions.h"
#include "server_reactions.h"
#include "client_reactions.h"

#include "boost/shared_ptr.hpp"

using namespace te;

#include <iostream>

//#############################################################################
void reaction_exit::invoke()
{
    my_server_.bailout();
}
//#############################################################################
void reaction_map_make::invoke()
{
    my_server_.my_map_creation_data_.size_long_ = size_long_;
    my_server_.my_map_creation_data_.size_latt_ = size_latt_;
    my_server_.my_map_creation_data_.make_map_now_ = true;
}
//-----------------------------------------------------------------------------
void reaction_map_make::setParams(datagram& dgram)
{
    size_long_ = dgram.params_[0];
    size_latt_ = dgram.params_[1];
}
//#############################################################################
#define ALS_PTR static_cast<action_leaf_send*> \
    (my_server_.my_actions_[leaf_send].get())

#define TERRAIN my_server_.my_terrain_

void reaction_area_req::invoke()
{
    size_t indice = 0;
    for(;left_lower_long <= right_upper_long;++left_lower_long)
    {
        for(size_t tmp = left_lower_latt;tmp <= right_upper_latt;++tmp, ++indice)
        {
            size_t version         = TERRAIN->getVersionOf(left_lower_long,tmp);
            size_t version2        = my_leaf_versions_[indice];
            leaf<tileData>& target = TERRAIN->getLeaf(left_lower_long,tmp);
            action_leaf_send* ptr  = ALS_PTR;

            if (version > version2)
            {
                ptr->setSize(left_lower_long,tmp);
                for (size_t x = 0; x < TERRAIN->size_factor_; ++x)
                {
                    for (size_t y = 0; y < TERRAIN->size_factor_; ++y)
                    {
                        ptr->addTile(target(x,y));
                    }
                }
                ptr->setVersion(TERRAIN->getVersionOf(left_lower_long,tmp));
                ptr->invoke();
            }
        }
    }
}
#undef TERRAIN
#undef ALS_PTR
//-----------------------------------------------------------------------------
void reaction_area_req::setParams(datagram &dgram)
{
    left_lower_long  = dgram.params_[0];
    left_lower_latt  = dgram.params_[1];
    right_upper_long = dgram.params_[2];
    right_upper_latt = dgram.params_[3];
    size_t bumper   = dgram.params_.size();
    size_t indice   = 4;
    my_leaf_versions_.resize(0);
    for(;indice < bumper;++indice)
    {
        size_t x = dgram.params_[indice];
        this->my_leaf_versions_.push_back(x);
    }
}
//#############################################################################
void reaction_set_map_size::setParams(datagram& dgram)
    {
        longitude_ = dgram.params_[0];
        lattitude_ = dgram.params_[1];
    }
//-----------------------------------------------------------------------------
void reaction_set_map_size::invoke()
    {
        my_client_.my_terrain_ = \
        
        boost::shared_ptr<terrain<tileData> >\
            (new terrain<tileData>(longitude_, lattitude_));

        client::render_area*  tmp = static_cast<client::render_area*>\
                    (my_client_.my_area_renderer_.get());

        tmp->resize ( longitude_/terrain<tileData>::size_factor_,\
                      lattitude_/terrain<tileData>::size_factor_ );
    }
//##############################################################################
#define TERRAIN my_client_.my_terrain_

void reaction_leaf_send::setParams(datagram& dgram)
    {
        size_t leaf_pos_long = dgram.params_[0];
        size_t leaf_pos_latt = dgram.params_[1];
        tileData inserter;
        size_t indice = 2;
//        std::cout << "leaf at" << leaf_pos_long << " " << leaf_pos_latt <<  "\n";
        for (size_t x = 0; x < TERRAIN->size_factor_;++x)
        {
            for (size_t y = 0; y < TERRAIN->size_factor_;++y,indice+=2)
            {
                inserter.msb = static_cast<unsigned int>(dgram.params_[indice]);
                inserter.lsb = static_cast<unsigned int>(dgram.params_[indice+1]);
                (*TERRAIN).getLeaf(leaf_pos_long,leaf_pos_latt)(x,y) = inserter;
            }
        }
        TERRAIN->setVersionOf(leaf_pos_long, leaf_pos_latt, *(--dgram.params_.end()));
    }
#undef TERRAIN
//##############################################################################
void reaction_date_and_time::setParams(datagram& dgram)
    {
        this->my_client_.my_year_       = dgram.params_[0];
        this->my_client_.my_month_      = dgram.params_[1];
        this->my_client_.my_dayOfMonth_ = dgram.params_[2];
        this->my_client_.my_dayOfYear_  = dgram.params_[3];
    }
//##############################################################################
