#include "calendar.h"
#include <iostream>

#ifdef WIN32
  #include "timing.h"
#else /* WIN32 */
  #include "timing_posix.h"
#endif

using namespace std;
using namespace te;


//create the game calendar

Calendar::Calendar(int StartYear,int FramesPerDay)
{
    Year = StartYear;
    NumFrames = FramesPerDay;
    DayFrame = 0;
    Month = 1;
    Day = 1;
    dayOfYear = 1;
   
    // determine if the start year is leap or not
    if ((((Year % 4) == 0) && ((Year % 100) != 0)) || ((Year % 400) == 0))
        LeapYear = true;
        else
        LeapYear = false;
};

//calculate the next day

void Calendar::NextDay (void)
{
//pass next frame
DayFrame++;

if (DayFrame >= NumFrames)
    {
    Display();    
    DayMs = getTicks();
    DayFrame = 0;
    ++Day;
    ++dayOfYear;

//do we have end of february
//non-leap year
    if ((Day == 29) && (Month == 2) && (LeapYear == false))
        {
           Day=01;
           Month++;
        };

//leap year
    if ((Day == 30) && (Month == 2) && (LeapYear == true))
        {
           Day=01;
           Month++;
        };

// end of april, june, september, november
    if (Day == 31)
        {
        if ((Month == 4) || (Month == 6) || (Month == 9) || (Month == 11))
           {
                Day=01;
                Month++;
           };
        }    
        
// end of the rest
    if (Day == 32)
        {
           Day = 01;
           Month++;
        };

// now - change the year
    if (Month == 13)
        {
           Month = 1;
           ++Year;
           dayOfYear = 1;
           //determine if it is leap year or not
           if ((((Year % 4) == 0) && ((Year % 100) != 0)) || ((Year % 400) == 0))
              LeapYear = true;
              else
              LeapYear = false;
        };
        };        
};

//display current date

void Calendar::Display (void)
    {
        cout << "day:" << (int)Day << " month:" << (int)Month;
        cout << " year:" << Year << " day of year:" << dayOfYear;
        cout << " time:"<< int(getTicks()-DayMs) << "\n";
    };    
