
namespace te
{
//#############################################################################
class Calendar
{
public: //---------------------------------------------------------------------
    /**
    * @remark
    *   ctor
    * @param
    *   StartYear: from which year to start
    * @param
    *   FramesPerDay: how many frames per one day
    */
    Calendar(int StartYear,int FramesPerDay);
//-----------------------------------------------------------------------------
    /**
    * @remark
    *   will change the day to the next one, controlling also month and year,
    *   each FramesPerDay frames
    */
    void NextDay();
//-----------------------------------------------------------------------------
    /**
    * @remark
    *   display current date (done automatically when date changes)
    */
    void Display();
//-----------------------------------------------------------------------------
    /**
    * @remark
    *   returns current redraw frame
    *   this is used for forcing redraw of a terrain leaf each x frames
    */
    int getDayOfYear()
    {
        return dayOfYear;
    }
//-----------------------------------------------------------------------------
    /**
    * @remark
    *   return current day in a month
    */
    int getDayOfMonth()
    {
        return Day;
    }
//-----------------------------------------------------------------------------
    /**
    * @remark
    *   get month of the year
    */
    int getMonth()
    {
        return Month;
    }
//-----------------------------------------------------------------------------
    /**
    * @remark
    *   get year
    */
    int getYear()
    {
        return Year;
    }
private: //--------------------------------------------------------------------
    /**
    * @remark
    * day of the month in the game time
    */
    int Day;
      
    /**
    * @remark 
    * month of the game time
    */
    int Month;
      
    /**
    * @remark 
    * year of the game time
    */
    int Year;
      
    /**
    * @remark 
    * do we have leap or normal year?
    */
    bool LeapYear;
      
    /**
    * @remark
    * which frame of the day currently passes
    */
    int DayFrame;
      
    /**
    * @remark
    * how many frames it takes to constitute a day
    * when DayFrames == NumFrames then we change the day
    */
    int NumFrames;
      
    /**
    * @remark
    * how many ms passed since the beginning of the day
    */
    int DayMs;

    /**
    * @remark
    * day of the year
    */
    int dayOfYear;
};
};