/*
* Adam Kadlubek 2006
* Terrain Generator for TTD and Transport Empire
* under GPL license
*/


#ifndef __THEMES_H__
#define __THEMES_H__

#include "gridArray.h"

/*
* in all cases this_ is the pointer to a result
*/

/*
* creates freeform terrain (no desert)
* par1 - amount of hills
* par2 - amount of water
*/

void freeForm (int hills, int water, gridArrayPtr* desert_,  gridArrayPtr* this_);

/*
* creates a classic arctic/tropic terrain (half one thing, half another)
*/

void classic (gridArrayPtr* desert_, gridArrayPtr* this_);

/*
* creates a valley themed terrain
* par1 - width of the river inside
*/

void valley (int width, gridArrayPtr* desert_, gridArrayPtr* this_);

/*
* creates a mountain range through the terrain
* par 1 - width of the shores
*/

void mountains (int width, gridArrayPtr* desert_, gridArrayPtr* this_);

/*
* creates a shoreline - ie mountains at one edge and sea on the other
* par1 - max height
* par2 - angle
*/

void shoreline (int height, int angle, gridArrayPtr* desert_, gridArrayPtr* this_);

/*
* creates an atol - ie an island circular in shape
* note - no desert will be created!
*/

void atolTheme (gridArrayPtr* this_);

/*
* creates a longmap - ie a twisty S shaped map
* par1 - amout of hilliness
*/

void longmap (int hills, gridArrayPtr* desert_, gridArrayPtr* this_);

#endif