/*
This file is a part of TRANSPORT EMPIRE
2006-2007 Copyright by Adam Kadlubek.

This file is licenced under GPL General Public Licence
*/

/**
* @remark
*   this is an interface class, hard wound into Ogre
*   this class is a field of the renderer
*
*/

#ifndef __RENDER_CONTENT_FACTORY_H__
#define __RENDER_CONTENT_FACTORY_H__

#include "../project_defaults.h"
#include "Ogre.h"
#include "../map.h"
#include "render_tile_factory.h"

namespace te
{
//#############################################################################
class render_content_factory
{
public: //---------------------------------------------------------------------
    /**
    * @remark
    *   ctor    
    */
    render_content_factory(Ogre::SceneManager* its_manager_) :
        my_tile_factory_(its_manager_)
    {
    }
//-----------------------------------------------------------------------------
    /**
    * @remark
    *   dtor
    */
    ~render_content_factory()
    {
    }
//-----------------------------------------------------------------------------
    /**
    * @remark
    *   get a name of a tile mesh of specified tile type
    *
    *   at first this method will check if such mesh exists
    *   if not, it will be created, otherwise just the name will
    *   be returned
    * @param
    *   tile to be created
    * @return
    *   pointer to a mesh
    */
    std::string& getTileMesh(te::tile& IN tile)
    {
        return this->my_tile_factory_.getTile(tile);
    }
//-----------------------------------------------------------------------------
    /**
    * @remark
    *   this structure is used to pass material prameters to the
    *   material factory
    */
    struct material_params
    {
    };
    //#########################################################################
    //-------------------------------------------------------------------------
    /**
    * @remark
    *   if such material was already created, its name will be returned
    *   otherwise it will be created
    */
    Ogre::MaterialPtr getTileMaterial(te::tileData& IN tile,\
        material_params& parameters)
    {
        return Ogre::MaterialPtr();
    }
private: //--------------------------------------------------------------------
    //#########################################################################
    class material_factory
    {
    };
    //#########################################################################
    te::render_tile_factory         my_tile_factory_;

};
//#############################################################################
};
#endif