#ifndef __SERVER_REACTIONS_H__
#define __SERVER_REACTIONS_H__

#include "action_map.h"

namespace te
{
class server;
//#############################################################################
class reaction_exit : public reaction
{
public: //---------------------------------------------------------------------
    reaction_exit(te::server& its_server) : my_server_(its_server){}
//-----------------------------------------------------------------------------
    void invoke();
private: //--------------------------------------------------------------------
    server& my_server_;
};
//#############################################################################
class reaction_map_make : public reaction
{
public: //---------------------------------------------------------------------
    reaction_map_make(te::server& its_server) : my_server_(its_server){}
//-----------------------------------------------------------------------------
    void setParams(datagram& dgram);
//-----------------------------------------------------------------------------
    void invoke();
private: //--------------------------------------------------------------------
    server& my_server_;
    size_t  size_long_;
    size_t  size_latt_;
};
//#############################################################################
class reaction_area_req : public reaction
{
public: //---------------------------------------------------------------------
    reaction_area_req(te::server& its_server) : my_server_(its_server){}
//-----------------------------------------------------------------------------
    void setParams(datagram& dgram);
//-----------------------------------------------------------------------------
    void invoke();
private: //--------------------------------------------------------------------
    server& my_server_;
    size_t left_lower_long;
    size_t left_lower_latt;
    size_t right_upper_long;
    size_t right_upper_latt;
    std::vector<size_t> my_leaf_versions_;
};
//#############################################################################
};
#endif